// #autoload
// #name         = EgoHUD
// #version      = 3.0
// #date         = 3.21.03
// #author       = Evita
// #web          = http://scripts.tribalwar.com/evita
// #description  = Tracks lifetime kills and deaths.  View totals in-game by binding a key in the control menu.  Can also view totals in options gui.
// #category     = Evitas Scripts
// #include      = support/callback.cs
// #include      = support/mute_tools.cs
// #config       = EgoHUDConfig

function EgoHUD::Init() {

	callback.add(CallbackMsgClientJoin,		"EgoHUD.Joined");
	callback.add(CallbackMsgLegitKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgTeamKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgHeadShotKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgVehicleKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgCTurretKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgHeadshotKill,		"EgoHUD.Killed");
	callback.add(CallbackMsgTurretKill,		"EgoHUD.Killed");
}

// Load saved stats from previous versions
if(isFile("prefs/EvEgoStats.cs") && (!$EvEgoStatsLoaded)) {

 	 exec("prefs/EvEgoStats.cs");
	 deleteFile("prefs/EvEgoStats.cs");
  	 $EvEgoStatsLoaded = true;
}

// Loads current versions
if(isFile("prefs/EvPrefs.cs") && (!$EvPrefsLoaded)) {

 	 exec("prefs/EvPrefs.cs");
  	 $EvPrefsLoaded = true;
}

if(!isObject(EgoHUD)) {

  	new ScriptObject(EgoHUD) {

    	class = EgoHUD;
    	version = "3.0";

	DamageName[1]  = "Blaster";
	DamageName[2]  = "Plasma";
	DamageName[3]  = "Chaingun";
	DamageName[4]  = "Disc";
	DamageName[5]  = "Grenade";
	DamageName[6]  = "Laser";
	DamageName[7]  = "ELF";
	DamageName[8]  = "Mortar";
	DamageName[9]  = "Missile";
	DamageName[10] = "Shocklance";
	DamageName[11] = "Mine";
	DamageName[12] = "na";
	DamageName[13] = "Ramming";
	DamageName[14] = "na";
	DamageName[15] = "Turret";
	DamageName[16] = "PlasmaTurret";
	DamageName[17] = "AATurret";
	DamageName[18] = "ELFTurret";
	DamageName[19] = "MortarTurret";
	DamageName[20] = "MissileTurret";
	DamageName[21] = "SpiderClamp";
	DamageName[22] = "Landspike";
	DamageName[23] = "SentryTurret";
	DamageName[24] = "na";
	DamageName[25] = "na";
	DamageName[26] = "ShrikeBlaster";
	DamageName[27] = "BellyTurret";
	DamageName[28] = "Bomb";
	DamageName[29] = "TankChaingun";
	DamageName[30] = "TankMortar";
	DamageName[31] = "Satchel";
	DamageName[32] = "MPBMissile";	

  	};
}

package EgoHUD {

function EgoHUD::Joined(%this, %msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid) {

	if(StrStr(%msgString, "Welcome to Tribes") != -1) {
	  %this.clientId = %clientId;
	  %this.playerName = detag(%clientName);
	}
}

function EgoHUD::Killed(%this, %msgType, %msgString, %victimName, %vgen, %vposs, %killerName, %kgen, %kposs, %damageType) {

	%this.killer = detag(%killerName);
	%this.victim = detag(%victimName);

	if(%this.victim $= %this.playerName) {
	  %weapon = %this.DamageName[%damageType];
	  $EvPrefs::LifeKills::TotalDeaths++;
	  $EvPrefs::LifeKills::Deaths[%weapon]++;
	}

	if(%this.killer $= %this.playerName) {
	  %weapon = %this.DamageName[%damageType];
	  $EvPrefs::LifeKills::TotalKills++;
	  $EvPrefs::LifeKills::Kills[%weapon]++;
	}
}

function EgoHUDOn(%val) {

	if(%val) {
	  	EgoHUD.DlgText(%this);

		$EgoHUD_PosX = getWord($pref::Video::resolution, 0) / 2 - 145;
		$EgoHUD_PosY = getWord($pref::Video::resolution, 1) / 2 - 250;

		EgoHUDFrame.setPosition($EgoHUD_PosX, $EgoHUD_PosY);

   		Canvas.popDialog("EgoHUDDlg");
   		Canvas.pushDialog("EgoHUDDlg", 100);
	}
}

function EgoHUDOff() {
   	Canvas.popDialog("EgoHUDDlg");
}

function quit() {

	if(!$EvPrefsSaved) {
	  export("$EvPrefs::*", "prefs/EvPrefs.cs", false);
	  $EvPrefsSaved = true;
	}

	parent::quit();
}

function OptionsDlg::onWake(%this) {

	if(!EgoStats.bind) {

		$RemapName[$RemapCount] = "EgoHUD";
		$RemapCmd[$RemapCount] = "EgoHUDOn";
		$RemapCount++;

		EgoStats.bind = true;
	}

	parent::onWake(%this);
}

function EgoHUDConfig::onWake(%this) {

	EgoHUD.Config();
	parent::onWake(%this);	
}

function EgoHUD::Config(%this) {

	%text = "\n<just:left>Total Kills: <just:right>" @ $EvPrefs::LifeKills::TotalKills @ "\n<just:left>Total Deaths: <just:right>" @ $EvPrefs::LifeKills::TotalDeaths @ "\n\n<just:left>Weapon <just:right>Kills/Deaths" ;

	for(%x=1;%x<=32;%x++) {
	  %weapon = %this.DamageName[%x];
	    if(%this.DamageName[%x] !$= "na") {
	      %text = %text @ "\n<just:left>" @ %weapon @ ":   <just:right>" @ $EvPrefs::LifeKills::kills[%weapon] @ " / " @ $EvPrefs::LifeKills::Deaths[%weapon];
	    }
	}

	EgoHUDConfigText.setText(%text);
}

function EgoHUD::DlgText(%this) {

	%text = "\n<just:left>Total Kills: <just:right>" @ $EvPrefs::LifeKills::TotalKills @ "\n<just:left>Total Deaths: <just:right>" @ $EvPrefs::LifeKills::TotalDeaths @ "\n\n<just:left>Weapon <just:right>Kills/Deaths" ;

	for(%x=1;%x<=32;%x++) {
	  %weapon = %this.DamageName[%x];
	    if(%this.DamageName[%x] !$= "na") {
	      %text = %text @ "\n<just:left>" @ %weapon @ ":   <just:right>" @ $EvPrefs::LifeKills::kills[%weapon] @ " / " @ $EvPrefs::LifeKills::Deaths[%weapon];
	    }
	}

	EgoHUDDlgText.setText(%text);
}

};

activatePackage(EgoHUD);

new GuiControl(EgoHUDConfig) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 520";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellPaneProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "178 20";
		extent = "290 500";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "EgoHUD";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "22 30";
			extent = "247 450";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
		};
		new GuiMLTextCtrl(EgoHUDConfigText) {
			profile = "clockProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "35 70";
			extent = "221 12";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			deniedSound = "InputDeniedSound";
		};
	};
};

new GuiControl(EgoHUDDlg) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 520";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl(EgoHUDFrame) {
		profile = "ShellWindowProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "178 20";
		extent = "290 500";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "EgoHUD";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";

		new ShellFieldCtrl() {
			profile = "ShellFieldProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "22 30";
			extent = "247 450";
			minExtent = "16 18";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
		};
		new GuiMLTextCtrl(EgoHUDDlgText) {
			profile = "clockProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "35 70";
			extent = "221 12";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			deniedSound = "InputDeniedSound";
		};
		new ShellBitmapButton(EgoHUDButton) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "75 40";
			extent = "140 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "EgoHUDOff();";
			helpTag = "0";
			text = "OK";
			simpleStyle = "0";
		};
	};
};

EgoHUD::Init();  